#ifndef _IPDF_
#define _IPDF_

#ifndef PLUGIN_LOADER

#include <stdlib.h>
#include <poppler.h>

//#include "../gloobus-preview-plugin-manager.h"
#include "../gloobus-preview-interface-document.h"

#define GP_IDOC_MAX_SIZE 102400

class iPdf : public iDocument
{
		PopplerDocument		*	m_document;
		PopplerPage			*	m_page;
		double					m_scale;

	public:
							iPdf						( void );
		virtual				~iPdf						( void );
		virtual	int			get_n_pages					( void );
		virtual	int			get_page_width				( void );
		virtual	int			get_page_height				( void );
		virtual	GdkPixbuf*	get_page_pixbuf				( int n_page );
		virtual	GtkWidget*	get_page					( int );
		virtual	void		end_plugin					( void );
				bool		load_doc					( void );

	private:
				void		get_scale					( void );
				int			get_page_height_unscaled	( void );
				int			get_page_width_unscaled		( void );
				char*		get_pdf_uri					( void );
				string		get_temp_path				( void );
				char*		path_to_uri					( string );
};

extern "C" interface * create() {
    return new iPdf;
}

extern "C" void destroy(interface * p) {
    delete (iPdf*)p;
}

extern "C" int getVersion() {
	return MANAGER_VERSION;
}

#endif

#ifdef PLUGIN_LOADER

PluginManager::register_plugin("pdf");

PluginManager::register_filetype("application/pdf", 1);
PluginManager::register_filetype("application/vnd.oasis.opendocument.text", 1);
PluginManager::register_filetype("application/msword", 1);
PluginManager::register_filetype("application/rtf", 1);
PluginManager::register_filetype("application/vnd.ms-excel", 1);
PluginManager::register_filetype("application/vnd.oasis.opendocument.spreadsheet", 1);
PluginManager::register_filetype("application/vnd.ms-powerpoint", 1);
PluginManager::register_filetype("application/vnd.sun.xml.calc", 1);
PluginManager::register_filetype("application/illustrator",1);

// TODO: add more filetypes supported by abiword and/or OpenOffice

#endif

#endif

